#ifndef _UTILS_H
#define _UTILS_H

#include <windows.h>
#include <stdio.h>

// useful macro for handling error codes
#define CHECK(return_value, call_description, error_label)			\
	if ((return_value) == FALSE) {						\
		fprintf(stderr, "(%s, %d): ", __FILE__, __LINE__);	\
		PrintLastError(call_description);					\
		result = EXIT_FAILURE;					\
		goto error_label;						\
	}

#define PIPE_NAME "\\\\.\\pipe\\myfifo"

void PrintLastError(const char *message) {
	char errBuff[1024];

	FormatMessage(
		FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_MAX_WIDTH_MASK,
		NULL,
		GetLastError(),
		0,
		errBuff,
		sizeof(errBuff) - 1,
		NULL);

	fprintf(stderr, "%s: %s\n", message, errBuff);
}

#endif